<template>
  <!-- Vue-tailwind dropdown component -->
  <t-dropdown
    ref="t-dropdown"
    :variant="variant"
    :variants="tDropdownStyle.variants"
    :classes="tDropdownStyle.classes"
    :fixed-classes="tDropdownStyle.fixedClasses"
    :toggle-on-hover="toggleOnHover"
    :toggle-on-click="toggleOnClick"
    :show.sync="localShowSync"
    @shown="shown"
    @hidden="hidden"
  >
    <!-- Trigger -->
    <template #trigger="tDropdownTriggerScope">
      <!--
        @slot Slot for trigger
        @binding {Object} v-bind - Dynamically bind trigger slot-scope from `TDropdown` [vue-tailwind](https://www.vue-tailwind.com/docs/dropdown/#trigger-slot) component
        @binding {string} variant - The dropdown variant
        @binding {string} className - The trigger element applied classes
      -->
      <slot
        name="trigger"
        v-bind="{...tDropdownTriggerScope}"
        :variant="variant"
        :trigger-classes="getElementCssClass('button')"
      >
        <!-- Default trigger button -->
        <button
          :class="getElementCssClass('button')"
          type="button"
          @mousedown="tDropdownTriggerScope.mousedownHandler"
          @focus="tDropdownTriggerScope.focusHandler"
          @keydown="tDropdownTriggerScope.keydownHandler"
          @blur="tDropdownTriggerScope.blurHandler"
        >
          <div class="flex gap-3 justify-between items-center cursor-pointer">
            <!-- Text -->
            <span>{{ triggerText }}</span>
            <!-- Shown indicator icon -->
            <v-icon
              :name="tDropdownTriggerScope.isShown ? 'sort-up' : 'sort-down'"
              class="fill-current"
              :style="{
                'margin-top': tDropdownTriggerScope.isShown ? '4px' : '-8px'
              }"
            />
          </div>
        </button>
      </slot>
    </template>

    <!-- t-dropdown default slot -->
    <template #default="tDropdownScope">
      <!--
        @slot Default slot
        @binding {Object} v-bind - Dynamically bind slot-scope from `TDropdown` [vue-tailwind](https://www.vue-tailwind.com/docs/dropdown/#default-slot) component
        @binding {string} variant - The dropdown variant
        @binding {string} dropdownClasses - The dropdown element applied classes
      -->
      <slot
        v-bind="{...tDropdownScope}"
        :variant="variant"
        :dropdown-classes="getElementCssClass('dropdown')"
      />
    </template>
  </t-dropdown>
</template>

<script>
// Mixins
import { Variantable, VariantableOptions } from '@/mixins/variantable'
// Component style
import Style from './style'

/**
 * VDropdown component
 * @requires ../dropdown-button/VDropdownButton.vue
 */
export default {
  name: 'VDropdown',
  mixins: [
    Variantable
  ],
  props: {
    /**
     * Define if button is full width
     */
    fluid: {
      type: Boolean,
      default: false
    },
    /**
     * @todo Document?
     */
    dropdownPosition: {
      type: String,
      default: 'absolute',
      validator: function (value) {
        // Si value est égale a left ou right
        if (value === 'absolute' || value === 'relative') {
          return true
        }

        return false
      }
    },
    /**
     * @todo Document?
     */
    dropdownAlign: {
      type: String,
      default: 'left',
      validator: function (value) {
        // Si value est égale a left ou right
        if (value === 'left' || value === 'right') {
          return true
        }

        return false
      }
    },
    /**
     * The trigger button text
     * @type {string}
     */
    triggerText: {
      type: String,
      default: 'Click me'
    },
    /**
     * @todo Document?
     */
    toggleOnHover: {
      type: Boolean,
      default: false
    },
    /**
     * @todo Document?
     */
    toggleOnClick: {
      type: Boolean,
      default: true
    },
    /**
     * Like a v-model for showing dropdown
     */
    show: {
      type: Boolean,
      default: false
    },
    /**
     * Event handler for "shown"
     */
    shown: {
      type: Function,
      default: () => {}
    },
    /**
     * Event handler for "hidden"
     */
    hidden: {
      type: Function,
      default: () => {}
    }
  },
  data () {
    return {
      localShowSync: false,
      tDropdownComponent: null
    }
  },
  computed: {
    /**
     * ⚠ We have to return css classes as array because vue-tailwind Tdropdown component
     * does not accept classes as object
     */
    tDropdownStyle () {
      return new VariantableOptions(this.overriddenStyle, { cssClassesFormat: 'array' })
    }
  },
  watch: {
    localShowSync: {
      immediate: true,
      handler: function (to, from) {
        this.$emit('update:show', to)
      }
    },
    show: function (to, from) {
      this.localShowSync = to
    },
    /**
     * Watch fluid to apply corresponding styles
     */
    fluid: function (to, from) {
      this.applyFluidStyle()
    },
    /**
     * Watch dropdownPosition to apply corresponding styles
     */
    dropdownPosition: function (to, from) {
      this.applyDropdownPositionStyle()
    },
    /**
     * Watch dropdownAlign to apply corresponding styles
     */
    dropdownAlign: function (to, from) {
      this.applyDropdownAlignStyle()
    }
  },
  created () {
    this.applyFluidStyle()
    this.applyDropdownPositionStyle()
    this.applyDropdownAlignStyle()
  },
  mounted () {
    // Set this.tDropdownComponent
    this.tDropdownComponent = this.$refs['t-dropdown']
  },
  methods: {
    /**
     * Set fuild style based on fluid prop
     */
    applyFluidStyle () {
      this.style.fixedClasses.wrapper['w-full'] = this.fluid
    },
    /**
     * Set dropdown position based on dropdownPosition prop
     */
    applyDropdownPositionStyle () {
      this.style.fixedClasses.dropdown.absolute = (this.dropdownPosition === 'absolute')
      this.style.fixedClasses.dropdown.relative = (this.dropdownPosition === 'relative')
    },
    /**
     * Set dropdown align based on dropdownAlign prop
     */
    applyDropdownAlignStyle () {
      this.style.fixedClasses.dropdown['left-0'] = (this.dropdownAlign === 'left')
      this.style.fixedClasses.dropdown['right-0'] = (this.dropdownAlign === 'right')
    }
  },
  // Variantable option
  style: Style
}
</script>

<style lang="scss">
// ...
</style>

<docs lang="md">

### Variants

```jsx
<!--
  Primary
-->
<p class="rsg--para-32">
  Variant: <b>primary</b>
</p>

<Dropdown
  variant="primary"
  v-slot="dropdown"
  trigger-text="Expand"
  class="mb-4"
>

  <DropdownButton
    :dropdown="dropdown"
  >
    Button 1
  </DropdownButton>

  <DropdownButton
    :dropdown="dropdown"
  >
    Button 2
  </DropdownButton>

</Dropdown>

<!--
  Theme 'light': alabaster
  Theme 'dark': tuna
-->
<p class="rsg--para-32">
  Variant: <b>{{ $app.ui.isTheme({
    'light': 'alabaster',
    'dark': 'tuna'
  }) }}</b>
</p>

<Dropdown
  :variant="$app.ui.isTheme({
    'light': 'alabaster',
    'dark': 'tuna'
  })"
  v-slot="dropdown"
  trigger-text="Expand"
>

  <DropdownButton
    :dropdown="dropdown"
  >
    Button 1
  </DropdownButton>

  <DropdownButton
    :dropdown="dropdown"
  >
    Button 2
  </DropdownButton>

</Dropdown>

<!--
  Theme 'light': white-smoke
  Theme 'dark': dark-jungle
-->
<p class="rsg--para-32">
  Variant: <b>{{ $app.ui.isTheme({
    'light': 'white-smoke',
    'dark': 'dark-jungle'
  }) }}</b>
</p>

<Dropdown
  :variant="$app.ui.isTheme({
    'light': 'white-smoke',
    'dark': 'dark-jungle'
  })"
  v-slot="dropdown"
  trigger-text="Expand"
>

  <DropdownButton
    :dropdown="dropdown"
  >
    Button 1
  </DropdownButton>

  <DropdownButton
    :dropdown="dropdown"
  >
    Button 2
  </DropdownButton>

</Dropdown>

```

### Use slots

```jsx
<Dropdown
  :variant="$app.ui.isTheme({
    'light': 'alabaster',
    'dark': 'tuna'
  })"
>

  <template
    #trigger="{
      mousedownHandler,
      focusHandler,
      keydownHandler,
      blurHandler,
      triggerClasses
    }"
  >
    <button
      @mousedown="mousedownHandler"
      @focus="focusHandler"
      @keydown="keydownHandler"
      @blur="blurHandler"
      :class="[
        ...triggerClasses,
        'text-left'
      ]"
      style="width: 160px;"
    >
      <v-icon name="cog"/> Actions
    </button>
  </template>

  <template #default="dropdown" >
    <DropdownButton
      :dropdown="dropdown"
    >
      <v-icon name="plus"/> Create
    </DropdownButton>
    <DropdownButton
      :dropdown="dropdown"
    >
      <v-icon name="trash"/> Delete
    </DropdownButton>
  </template>

</Dropdown>
```

</docs>
